//---------------------------------------------------------------------------

#ifndef NymDlgsH
#define NymDlgsH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
#include <Buttons.hpp>
#include <Menus.hpp>

#include "NymProfiles.h"
#include "PGPsdk.h"
//---------------------------------------------------------------------------

bool __fastcall OpenNymDialog(TForm *Owner, AnsiString &Nym, TPGPsdk *PGP);

bool __fastcall CreateNym(TForm *Owner, TPGPsdk *PGP, const AnsiString &PGPKey,
   bool ReplyBlock, const AnsiString &Address, int ChainLength);
bool __fastcall ModifyNym(TForm *Owner, AnsiString &Nym, TPGPsdk *PGP);
AnsiString __fastcall NymIndexStr(TStrings *nym);

const int MaxDatas = 16;

class TNymDlg : public TForm
{
__published:	// IDE-managed Components
        TPageControl *PageControl1;
        TTabSheet *TabSheet1;
        TLabel *Label2;
        TLabel *Label3;
        TEdit *Name;
        TComboBox *oldPGPkey;
        TButton *OkBtn;
        TButton *CancelBtn;
        TTabSheet *TabSheet2;
        TTabSheet *TabSheet3;
        TTabSheet *TabSheet4;
        TRichEdit *NotePad;
        TEdit *UserID;
        TComboBox *NymServers;
        TLabel *Label7;
        TRichEdit *History;
        TRadioButton *Prof0;
        TRadioButton *Prof1;
        TRadioButton *Prof2;
        TRadioButton *Prof3;
        TRadioButton *Prof4;
        TRadioButton *Prof5;
        TRadioButton *Prof6;
        TRadioButton *Prof7;
        TRadioButton *Prof8;
        TRadioButton *Prof9;
        TLabel *Label6;
        TLabel *ModifyNymName;
        TRichEdit *LogPad;
        TTimer *Timer1;
        TTabSheet *TabSheet5;
        TRichEdit *ReplayPad;
        TLabel *NoteDate;
        TLabel *LogDate;
        TLabel *ReplayDate;
        TSpeedButton *NoteCutBtn;
        TSpeedButton *NoteCopyBtn;
        TSpeedButton *NotePasteBtn;
        TSpeedButton *NotePrintBtn;
        TPopupMenu *NoteMenu;
        TMenuItem *NoteCutItem;
        TMenuItem *NoteCopyItem;
        TMenuItem *NotePasteItem;
        TMenuItem *NoteSelectAllItem;
        TMenuItem *N2;
        TMenuItem *NotePrintItem;
        TSpeedButton *HistCopyBtn;
        TSpeedButton *HistPrintBtn;
        TPopupMenu *HistoryMenu;
        TMenuItem *HistCopyItem;
        TMenuItem *HistPrintItem;
        TMenuItem *HistSelectAllItem;
        TMenuItem *N3;
        TSpeedButton *LogCopyBtn;
        TSpeedButton *LogPrintBtn;
        TSpeedButton *ReplaySendBtn;
        TSpeedButton *ReplayCopyBtn;
        TSpeedButton *ReplayPrintBtn;
        TPopupMenu *ReplayMenu;
        TPopupMenu *LogMenu;
        TMenuItem *LogCopyItem;
        TMenuItem *LogSelectAllItem;
        TMenuItem *N5;
        TMenuItem *LogPrintItem;
        TMenuItem *ReplayCopyItem;
        TMenuItem *ReplaySelectAllItem;
        TMenuItem *N6;
        TMenuItem *ReplayPrintItem;
        TMenuItem *N1;
        TMenuItem *ReplaySendItem;
        TButton *KeyImportBtn;
        TGroupBox *GroupBox1;
        TCheckBox *OptAck;
        TCheckBox *OptSign;
        TCheckBox *OptCrypt;
        TCheckBox *OptDisable;
        TCheckBox *OptFixed;
        TCheckBox *OptFinger;
        TCheckBox *OptBcc;
        TGroupBox *GroupBox2;
        TTreeView *ReplyBlocks;
        TButton *NewBtn;
        TButton *ModRBBtn;
        TButton *DelRBBtn;
        TCheckBox *RetiredBox;
        TButton *SourceBtn;
        TLabel *Label4;
        TPopupMenu *PopupMenu1;
        TMenuItem *PopNymCreateItem;
        TPanel *Panel1;
        TSpeedButton *MessageBtn;
        TMenuItem *PopNymModifyItem;
        TMenuItem *PopNymDeleteItem;
        TMenuItem *N4;
        TMenuItem *PopReplayItem;
        TMenuItem *N7;
        TMenuItem *PopFromNymItem;
        TTimer *Timer2;
        TLabel *Label1;
        TEdit *PGPkey;
        TRadioButton *Prof10;
        void __fastcall FormCloseQuery(TObject *Sender, bool &CanClose);
        void __fastcall Prof0Click(TObject *Sender);
        void __fastcall HistorySelectionChange(TObject *Sender);
        void __fastcall CopyBtnClick(TObject *Sender);
        void __fastcall Timer1Timer(TObject *Sender);
        void __fastcall FormShow(TObject *Sender);
        void __fastcall NoteCutItemClick(TObject *Sender);
        void __fastcall NoteCopyItemClick(TObject *Sender);
        void __fastcall NotePasteItemClick(TObject *Sender);
        void __fastcall NoteSelectAllItemClick(TObject *Sender);
        void __fastcall NoteMenuPopup(TObject *Sender);
        void __fastcall NotePrintItemClick(TObject *Sender);
        void __fastcall NotePadSelectionChange(TObject *Sender);
        void __fastcall HistoryMenuPopup(TObject *Sender);
        void __fastcall ReplayPadSelectionChange(TObject *Sender);
        void __fastcall LogPadSelectionChange(TObject *Sender);
        void __fastcall HistCopyItemClick(TObject *Sender);
        void __fastcall HistSelectAllItemClick(TObject *Sender);
        void __fastcall HistPrintItemClick(TObject *Sender);
        void __fastcall ReplayMenuPopup(TObject *Sender);
        void __fastcall LogCopyItemClick(TObject *Sender);
        void __fastcall LogSelectAllItemClick(TObject *Sender);
        void __fastcall LogPrintItemClick(TObject *Sender);
        void __fastcall LogMenuPopup(TObject *Sender);
        void __fastcall ReplayCopyItemClick(TObject *Sender);
        void __fastcall ReplaySelectAllItemClick(TObject *Sender);
        void __fastcall ReplayPrintItemClick(TObject *Sender);
        void __fastcall NewRBBtnClick(TObject *Sender);
        void __fastcall ModRBBtnClick(TObject *Sender);
        void __fastcall ReplyBlocksClick(TObject *Sender);
        void __fastcall RetiredBoxClick(TObject *Sender);
        void __fastcall SourceBtnClick(TObject *Sender);
        void __fastcall DelRBBtnClick(TObject *Sender);
        void __fastcall PopNymCreateItemClick(TObject *Sender);
        void __fastcall MessageBtnClick(TObject *Sender);
        void __fastcall PopNymModifyItemClick(TObject *Sender);
        void __fastcall PopNymDeleteItemClick(TObject *Sender);
        void __fastcall PopReplayItemClick(TObject *Sender);
        void __fastcall PopFromNymItemClick(TObject *Sender);
        void __fastcall Timer2Timer(TObject *Sender);
        void __fastcall KeyImportBtnClick(TObject *Sender);
        void __fastcall PopupMenu1Popup(TObject *Sender);
        void __fastcall RandomMouseMove(TObject *Sender,
          TShiftState Shift, int X, int Y);
private:	// User declarations
public:		// User declarations
        TNymProfile *Profile;
        TStringList *Data[MaxDatas], *OrgBlocks, *PublicKey, *SecretKey;
        AnsiString OrgNym, OrgUserID, OrgServer, OrgPgpKey, OrgName, OrgOptions;
        bool OrgRetired, SavedToProfile, Virgin; //RBModified;
        int ChainLength;     // for autogen rb
        AnsiString Address;  // for autogen rb
        TColor WinColor;
        //TPGPsdk *PGP;

        virtual __fastcall TNymDlg(TForm* Owner);
        virtual __fastcall TNymDlg(TForm* Owner, TPGPsdk *pgp);
        virtual __fastcall ~TNymDlg();
        void __fastcall LoadFromProfile();
        void __fastcall SaveToProfile();
        void __fastcall SaveNym();
        int  __fastcall LoadNym(const AnsiString &Nym);
        bool __fastcall CheckSaveB4Message();
        //void __fastcall LoadPGPKeys();
        void __fastcall EnableProfile(int pos);
        void __fastcall SetHistoryBtns();
        void __fastcall SetReplayBtns();
        void __fastcall SetNoteBtns();
        void __fastcall SetLogBtns();

        int  __fastcall GetReplyBlocks(TStrings *blocks);
        bool __fastcall ReplyBlocksModified();
        void __fastcall SetOptions(const AnsiString &opts);
        void __fastcall EnableForm(bool enable);
        AnsiString __fastcall GetOptions();
        bool __fastcall Modified();
        AnsiString __fastcall Nym();

        bool __fastcall IsNymDomain(const AnsiString &Nym);
        bool __fastcall NymExists(const AnsiString &Nym);
};

void __fastcall GetNymServers(TStrings *Servers);

//---------------------------------------------------------------------------
extern PACKAGE TNymDlg *NymDlg;
//---------------------------------------------------------------------------
#endif
