//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Global2.h"
#include "RBEkxDlgs.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TRBEkxDlg *RBEkxDlg;
//---------------------------------------------------------------------------

bool __fastcall OpenEncryptKeyDialog(TForm *Owner, AnsiString &Directive,
   const AnsiString &Caps)
{
   RBEkxDlg = new TRBEkxDlg(Owner);

   RBEkxDlg->orgdir = Directive;
   RBEkxDlg->Password->Text = Directive.SubString(Directive.Pos(":") + 2, 1024);
   RBEkxDlg->Caps = Caps;

   RBEkxDlg->ShowModal();

   bool ok = RBEkxDlg->ModalResult == mrOk;
   if (ok)
   {
      Directive = RBEkxDlg->newdir;
   }

   delete RBEkxDlg;
   return ok;
}
//---------------------------------------------------------------------------

__fastcall TRBEkxDlg::TRBEkxDlg(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------

bool __fastcall TRBEkxDlg::HasCap(const AnsiString &Cap)
{
   return Caps.Pos(" " + Cap + " ") > 0;
}
//---------------------------------------------------------------------------

void __fastcall TRBEkxDlg::FormShow(TObject *)
{
   KeyBtn->Enabled = HasCap("ek");
   DESBtn->Enabled = HasCap("ekx");
   CASBtn->Enabled = HasCap("ekx");
   DESBtn->Checked = orgdir.Pos("Encrypt-3DES: ") == 1;
   CASBtn->Checked = orgdir.Pos("Encrypt-CAST: ") == 1;
   KeyBtn->Checked = orgdir.Pos("Encrypt-Key: ") == 1;
}
//---------------------------------------------------------------------------

void __fastcall TRBEkxDlg::FormCloseQuery(TObject *, bool &)
{
   if (KeyBtn->Checked) newdir = "Encrypt-Key: ";
   if (DESBtn->Checked) newdir = "Encrypt-3DES: ";
   if (CASBtn->Checked) newdir = "Encrypt-CAST: ";
   newdir += Password->Text;
}
//---------------------------------------------------------------------------

