//---------------------------------------------------------------------------

#ifndef RBWizDlgsH
#define RBWizDlgsH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ComCtrls.hpp>
#include <Buttons.hpp>
#include <ExtCtrls.hpp>
//---------------------------------------------------------------------------
bool __fastcall RunReplyBlockWizard(TForm *Owner, const AnsiString &Nym, TStrings *ReplyBlock);
bool __fastcall FullAutoReplyBlockWizard(TForm *Owner, const AnsiString &Nym, TStrings *ReplyBlock,
   const AnsiString &EmailAddress, int ChainLength);
bool __fastcall ModifyReplyBlockWizard(TForm *Owner, const AnsiString &Nym, TStrings *ReplyBlock);

class TReplyBlock : public TStringList
{
};

class TRBWizardDlg : public TForm
{
__published:	// IDE-managed Components
        TButton *BackBtn;
        TButton *NextBtn;
        TButton *CancelBtn;
        TLabel *Label4;
        TPanel *Panel1;
        TPageControl *PageControl;
        TTabSheet *LengthTab;
        TLabel *Label2;
        TLabel *Label6;
        TLabel *Label14;
        TLabel *Label15;
        TRadioButton *EmailAddress;
        TRadioButton *Newsgroup;
        TEdit *Destination;
        TCheckBox *PostDirect;
        TCheckBox *Esub;
        TButton *HelperBtn;
        TTabSheet *SelectTab;
        TLabel *Label3;
        TLabel *Label7;
        TLabel *Label10;
        TSpeedButton *LegBtn;
        TLabel *Label11;
        TSpeedButton *CapBtn;
        TSpeedButton *BrokeBtn;
        TSpeedButton *DelRemBtn;
        TListBox *ListBox1;
        TListBox *Chain;
        TBitBtn *CopyBtn;
        TComboBox *RemSelBox;
        TTabSheet *Mail2newsTab;
        TLabel *Label12;
        TLabel *Label13;
        TLabel *Label16;
        TLabel *Label17;
        TSpeedButton *DelM2nBtn;
        TListBox *M2nGateways;
        TBitBtn *CopyM2nBtn;
        TListBox *UseGateways;
        TTabSheet *ReviewTab;
        TLabel *Label9;
        TLabel *Label1;
        TLabel *Label5;
        TLabel *Label8;
        TTreeView *RBView;
        TButton *AdvBtn;
        TButton *ModBtn;
        TButton *SourceBtn;
        TButton *ProbBtn;
        void __fastcall BackBtnClick(TObject *Sender);
        void __fastcall NextBtnClick(TObject *Sender);
        void __fastcall PageControlChanging(TObject *Sender,
          bool &AllowChange);
        void __fastcall NewsgroupClick(TObject *Sender);
        void __fastcall EmailAddressClick(TObject *Sender);
        void __fastcall ListBox1DrawItem(TWinControl *Control, int Index,
          TRect &Rect, TOwnerDrawState State);
        void __fastcall ListBox1Click(TObject *Sender);
        void __fastcall CopyBtnClick(TObject *Sender);
        void __fastcall ChainClick(TObject *Sender);
        void __fastcall DelRemBtnClick(TObject *Sender);
        void __fastcall LegBtnClick(TObject *Sender);
        void __fastcall RBViewClick(TObject *Sender);
        void __fastcall FormCloseQuery(TObject *Sender, bool &CanClose);
        void __fastcall RemSelBoxChange(TObject *Sender);
        void __fastcall CapBtnClick(TObject *Sender);
        void __fastcall BrokeBtnClick(TObject *Sender);
        void __fastcall ModBtnClick(TObject *Sender);
        void __fastcall AdvBtnClick(TObject *Sender);
        void __fastcall SourceBtnClick(TObject *Sender);
        void __fastcall FormShow(TObject *Sender);
        void __fastcall ProbBtnClick(TObject *Sender);
        void __fastcall HelperBtnClick(TObject *Sender);
        void __fastcall PostDirectClick(TObject *Sender);
        void __fastcall M2nGatewaysDrawItem(TWinControl *Control,
          int Index, TRect &Rect, TOwnerDrawState State);
        void __fastcall M2nGatewaysClick(TObject *Sender);
        void __fastcall CopyM2nBtnClick(TObject *Sender);
        void __fastcall UseGatewaysClick(TObject *Sender);
        void __fastcall DelM2nBtnClick(TObject *Sender);
        void __fastcall UseGatewaysDrawItem(TWinControl *Control, int Index,
          TRect &Rect, TOwnerDrawState State);
private:	// User declarations
public:		// User declarations
        int autochainlength;
        bool modify, forward;
        TReplyBlock *ReplyBlock;
        AnsiString Nym, Probability, newsgroup, emailaddr, lastdefs;
        TStringList *mlist, *rlist, *brokenchains, *capstrings;
        __fastcall TRBWizardDlg(TComponent* Owner);
        virtual __fastcall ~TRBWizardDlg();

        void __fastcall LoadRemailers();
        void __fastcall LoadRemailersPostOnly();
        void __fastcall LoadRemailersPostEsubOnly();
        void __fastcall LoadRemailersExitEsubOnly();
        void __fastcall LoadRemailersExitOnly();
        void __fastcall LoadRemailersEsubOnly();
        void __fastcall LoadRemailersAll();

        bool __fastcall HasCap(const AnsiString &Remailer, const AnsiString &Cap);
        AnsiString __fastcall GetRemailerFromDomain(const AnsiString &Domain);
        AnsiString __fastcall GetCaps(AnsiString Remailer);
        AnsiString __fastcall GetCurrentCaps();
        AnsiString __fastcall GetMail2NewsGateways();
        AnsiString __fastcall BackEndRemailer(const AnsiString &NymServer);
        bool __fastcall AutoGenReplyBlock(int remailers);

        void __fastcall GetRemailersBeforeAndAfter(AnsiString &RemBefore, AnsiString &RemAfter);
        bool __fastcall RemailerPrecedesOrFollowsSelf(const AnsiString &Remailer,
           const AnsiString &RemBefore, const AnsiString &RemAfter);
        void __fastcall GetBrokenCpunkChains(TStrings *Rlist, TStrings *Broken);
        void __fastcall GetCapStrings(TStrings *Rlist, TStrings *CapStrings);
        bool __fastcall RemailerIsBroken(const AnsiString &remailer,
           const AnsiString &rembefore, const AnsiString &remafter, int &X);
        bool __fastcall IsBroken(const AnsiString &Remailer1, const AnsiString &Remailer2);
        AnsiString __fastcall FixBrokenLine(AnsiString &line, int p);
        AnsiString __fastcall GetRemailerAt(int Position);

        void __fastcall LoadSelectFromLength();
        void __fastcall LoadReviewFromSelect();
        void __fastcall LoadSelectFromReview();
        void __fastcall LoadLengthFromSelect();

        AnsiString __fastcall TheDestination();
        AnsiString __fastcall LastInChain();
        void __fastcall ChainClear();

        int  __fastcall UpDayCount(const AnsiString &remailer);
        bool __fastcall GenReplyBlockToGroup(int Length);
        bool __fastcall GenReplyBlockToEmail(int Length);
        AnsiString __fastcall GetNextRemailer();
        void __fastcall EnableSelect(bool enable);

        void __fastcall ProcessKidsForReview(TTreeNode *node, int position);
        void __fastcall AddEkAndLatent(const AnsiString &remailer,
           TStrings *directives);
};

//---------------------------------------------------------------------------
extern PACKAGE TRBWizardDlg *RBWizardDlg;
//---------------------------------------------------------------------------
#endif
