//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop
#include <clipbrd.hpp>

#include "ViewRptsDlgs.h"
#include "printdlgs2.h"
#include "global2.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TViewRptsDlg *ViewRptsDlg;
//---------------------------------------------------------------------------

void __fastcall ViewNymReport(TForm *Owner, const AnsiString &Title, TStrings *Report)
{
   ViewRptsDlg = new TViewRptsDlg(Owner);
   ViewRptsDlg->Caption = Title;
   ViewRptsDlg->Viewer->Lines->AddStrings(Report);
   ViewRptsDlg->ShowModal();
   delete ViewRptsDlg;
}
//---------------------------------------------------------------------------

__fastcall TViewRptsDlg::TViewRptsDlg(TComponent* Owner)
        : TForm(Owner)
{
   Viewer->Clear();

   TColor color;
   LoadFonts(AppIni(), NymIni, color, Font, NULL, Viewer->Font);
   Viewer->Color = color;
}
//---------------------------------------------------------------------------

void __fastcall TViewRptsDlg::PopSaveItemClick(TObject *Sender)
{
   if (SaveDialog->Execute())
   {
      Viewer->Lines->SaveToFile(SaveDialog->FileName);
   }
}
//---------------------------------------------------------------------------

void __fastcall TViewRptsDlg::PopCutItemClick(TObject *Sender)
{
   Viewer->CutToClipboard();
   PasteBtn->Enabled = true;
}
//---------------------------------------------------------------------------

void __fastcall TViewRptsDlg::PopCopyItemClick(TObject *Sender)
{
   Viewer->CopyToClipboard();
   PasteBtn->Enabled = true;
}
//---------------------------------------------------------------------------

void __fastcall TViewRptsDlg::PopPasteItemClick(TObject *Sender)
{
   Viewer->PasteFromClipboard();
}
//---------------------------------------------------------------------------

void __fastcall TViewRptsDlg::PopSelectAllItemClick(TObject *Sender)
{
   Viewer->SelectAll();
}
//---------------------------------------------------------------------------

void __fastcall TViewRptsDlg::PopPrintItemClick(TObject *Sender)
{
   if (MsgBox(this, "Print the report now?", MT_CONFIRM, MB_OKCANCEL) == IDOK)
   {
      PrintDocument(this, Caption, Viewer->Lines, Viewer->Font);
   }
}
//---------------------------------------------------------------------------

void __fastcall TViewRptsDlg::PopupMenuPopup(TObject *Sender)
{
   bool hassel = Viewer->SelLength > 0;
   PopCutItem->Enabled = hassel;
   PopCopyItem->Enabled = hassel;
   PopPasteItem->Enabled = Clipboard()->HasFormat(CF_TEXT);
}
//---------------------------------------------------------------------------

void __fastcall TViewRptsDlg::ViewerSelectionChange(TObject *Sender)
{
   bool hassel = Viewer->SelLength > 0;
   CutBtn->Enabled = hassel;
   CopyBtn->Enabled = hassel;
   PasteBtn->Enabled = Clipboard()->HasFormat(CF_TEXT);
}
//---------------------------------------------------------------------------
